library(foreach)
library(doMPI)

func = function(i){
  Sys.sleep(5)
  computation_node = Sys.info()[["nodename"]]
  result = i * i
  
  list( computation_node = computation_node, result = result)
}


cl <- startMPIcluster()
registerDoMPI(cl)

vec = 1:5

Sys.time()
results = foreach( i = vec ) %dopar% func(i)
Sys.time()


closeCluster(cl)
mpi.finalize()

df = as.data.frame( do.call(rbind, results) )
compute_nodes = unique( unlist( df$computation_node ) )

print("Result")
print( unlist(df$result) )

print(paste( "Coordinator node:", Sys.info()[["nodename"]] ))
print("Computation nodes:")
print(compute_nodes)

