library(foreach)
library(doSNOW)

system("cd multinode_sock && qsub reserve_nodes.qsub")
Sys.sleep(5)

nodes = readLines( file("multinode_sock/nodes_list.txt") )




func = function(i){
  Sys.sleep(5)
  computation_node = Sys.info()[["nodename"]]
  result = i * i
  
  list( computation_node = computation_node, result = result)
}





cl <- makeCluster( nodes, type = "SOCK", rscript = "/pico/home/userinternal/mvit0000/bin/Rscript_with_module")
registerDoSNOW(cl)

vec = 1:5

Sys.time()
results = foreach( i = vec ) %dopar% func(i)
Sys.time()


stopCluster(cl)

df = as.data.frame( do.call(rbind, results) )
compute_nodes = unique( unlist( df$computation_node ) )

print("Result")
print( unlist(df$result) )

print(paste( "Coordinator node:", Sys.info()[["nodename"]] ))
print("Computation nodes:")
print(compute_nodes)


